/*
 * CSSCenario.h
 *
 *  Created on: 26 avr. 2010
 *      Author: bboulay
 */

#ifndef CSSCENARIO_H_
#define CSSCENARIO_H_

#include <string>
#include <map>
#include <vector>
#include <iostream>
#include <fstream>
#include <cctype>
#include <algorithm>
#include "CComponent.h"
#include "CConstraint.h"
#include "CParserTool.h"

class CConstraint;

class CSScenario {
public:
	CSScenario();
	virtual ~CSScenario();

	void read(std::string i_block, std::string i_type, std::map<std::string, double> i_thresholdByEventType, std::map<std::string, int> i_levelAlarm);
	void readPhysicalObjects(std::string i_value);
	void readConstraints(std::string i_value);
	void readComponents(std::string i_value);
	void readAlarm(std::string i_value, std::map<std::string, int> i_levelAlarm);
	void readMiscellaneous(std::string i_value);

	void fillConstraintsConstants(std::map<std::string, double> i_allConstants);
	void classifyConstraints();
	void rewriteAgentOperator();



	void print();


public:
	int m_id;
	std::string m_type;
	std::string m_name;
	std::string m_alarm_text;
	//type (Ex. Person), names(shortcuts,e.g., p1,z1) of physical objects
	std::map<std::string, std::vector<std::string> > m_physical_objects;

	//name, type of object (including component)
	std::map<std::string, std::string> 		m_po;

	//order in the Scenario model definition, name of physical objects
	std::map<int, std::string> 	m_POorder;
	//std::map<std::string, int> m_POorderInv;
	std::vector<CComponent*> 	m_components;
	std::vector<CConstraint*> 	m_constraints;
	std::map<std::string, std::map<std::string, std::string>  > m_miscellaneous;
	std::string 			m_alarm_level;
	int 	m_alarm_int;
	double 	m_threshold;

	int 	m_componentToRecognise;
	bool 	m_use;

public:
	static int m_number;

};







#endif /* CSSCENARIO_H_ */
