#include "CSBasicType.h"
#include "CSAllTypes.h"
#include "CAllClasses.h"
#include <iostream>
#include <map>
#include <tr1/memory>
//#include <std::tr1/make_shared.hpp>

#ifndef CSAGENT_H
#define CSAGENT_H

class CSAgent{
public:
	CSAgent();
	CSAgent(std::string i_type, int i_id);
	CSAgent(int i_id, bool i_const);
	virtual ~CSAgent();

	void static readAllObjects(std::string i_file);
	void static printAllObjects();

	//CSBasicType* getValue(std::string i_attribute);
	//void setValue(std::string i_attribute, CSBasicType* i_value);
	//CSBasicType* getHValue(std::string i_attribute, int i_pos);
	//void setHValue(std::string i_attribute, CSBasicType* i_value, int i_pos);
	//std::map<int,CSBasicType*> getHAllValue(std::string i_attribute);
	void setFrameID(int i_pos);

	void set(std::string i_attribute, std::tr1::shared_ptr<CSBasicType> i_value, int i_pos);
	void setType(std::tr1::shared_ptr<CSString> i_type, int i_pos);
	std::tr1::shared_ptr<CSBasicType> get(std::string i_attribute, int i_pos);
	std::tr1::shared_ptr<CSBasicType> get(std::string i_attribute);
	std::vector<std::tr1::shared_ptr<CSBasicType> > getAll(std::string i_attribute);

public:
	std::tr1::shared_ptr<CSString> 		Name;
	std::tr1::shared_ptr<CSInt> 		ID;
	std::tr1::shared_ptr<CSString> 		Class;
	std::tr1::shared_ptr<CSInterval> 	Interval;
	
	std::string 				Type;
	std::string 				m_type;
	int 					m_id;
	int 					m_idEngine;
	int frame_id;

	bool m_constant;
	bool m_exist;
	//ID of the scenario where the agent is used / 1
	std::map<int,int> m_usedInScenarioID;
	std::map<int, int> m_InTime;

	//attribute name, IDTime, attribute value
	std::map<std::string, std::tr1::shared_ptr<CSBasicType> > m_attributes;

	//Object type, attribute name, attribute type
	static std::map<std::string, std::map<std::string, std::string> > m_allAttributes;
	//Object type, all the sons type
	static std::map<std::string, std::vector<std::string> > m_allObjectTypes;
	static std::map<std::string, bool> m_constantObjects;
	static unsigned int m_historySize;

	double m_confidence;
};

#endif
