#ifndef SUPCOMPOSERNODEVIEW_H
#define SUPCOMPOSERNODEVIEW_H

#include "supComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeafView.h>

#include <QtCore>

class supComposerNodeViewPrivate;

class SUPCOMPOSER_EXPORT supComposerNodeView : public QObject, public dtkComposerNodeLeafView
{
    Q_OBJECT

public:
     supComposerNodeView(void);
    ~supComposerNodeView(void);

public:
    void run(void);

public:
    inline QString type(void) {
        return "supView";
    }

    inline QString titleHint(void) {
        return "View";
    }

    inline QString inputLabelHint(int port) {
        switch(port) {
        case 0:
            return "image";
        case 1:
            return "segmentation";
        case 2:
            return "blobs";
        default:
            return dtkComposerNodeLeafView::inputLabelHint(port);
        };
    }
    inline bool isAbstractView(void) const {
        return false;
    }

    inline QString abstractViewType(void) const {
        return "supView";
    }

private:
    supComposerNodeViewPrivate *d;
};

#endif
