#ifndef SUPABSTRACTDATACALIBRATIONWITHDEPTH_H
#define SUPABSTRACTDATACALIBRATIONWITHDEPTH_H

#include "supAbstractDataCalibration.h"

#include "supCoreExport.h"

#include "ContextElement.h"
#include "supDataContext.h"

class supAbstractDataCalibrationWithDepthPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractDataCalibrationWithDepth interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractDataCalibrationWithDepth : public supAbstractDataCalibration
{
    Q_OBJECT

public:
             supAbstractDataCalibrationWithDepth(void);
             supAbstractDataCalibrationWithDepth(const supAbstractDataCalibrationWithDepth& other);
    virtual ~supAbstractDataCalibrationWithDepth(void);

public:
    virtual supAbstractDataCalibrationWithDepth *clone(void);

public:
    supAbstractDataCalibrationWithDepth& operator = (const supAbstractDataCalibrationWithDepth& other);

protected:
    virtual void copy(const supAbstractDataCalibration& other);

public:
    QString identifier(void) const;

public:
    // Setter Methods
    void setDepthInformation(const cv::Mat& depth);
    void setDepthInformation(const QString& rawFile);
    //Getter Methods
    const cv::Mat& getDepthInformation() const;

public: // Tools
    //float depthVal(const double c, const double r,const QString& file);
    float depthVal(const double c, const double r);
    virtual cv::Point3d imageToWorld(const cv::Point2d& i_pos2d);
    // virtual cv::Point3d imageToWorld(const cv::Point2d& i_pos2d);
    virtual cv::Point2d worldToImage(const cv::Point3d& i_pos3d);

    cv::Point3d             pointProjectionOntoPlane(cv::Point3d l_point, std::vector<double>& l_planeEquationCoefficients);

    double                  vectorMagnitude(cv::Point3d l_point);

    double                  computePointDistanceToPlane( cv::Point3d l_point, std::vector<double>& l_planeEquationCoefficients);

    std::vector<double>     computePlaneEquationFromContextualObjects(const supDataContext * pContext);

    std::vector<double>     computePlaneEquationFromContextualObject(ContextElement l_contextualObject);

private:
    DTK_DECLARE_PRIVATE(supAbstractDataCalibrationWithDepth)
};

#endif

