#ifndef SUPABSTRACTPROCESSDATAFLOWREADER_H
#define SUPABSTRACTPROCESSDATAFLOWREADER_H

#include "supAbstractProcess.h"

#include "supCoreExport.h"

#include "supAbstractData.h"

#include <QFile>
#include <QDomElement>
#include <QDomDocument>

class supAbstractProcessDataFlowReaderPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessDataFlowReader interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessDataFlowReader : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessDataFlowReader(void);
             supAbstractProcessDataFlowReader(const supAbstractProcessDataFlowReader& other);
    virtual ~supAbstractProcessDataFlowReader(void);


    QList<supAbstractData*>   getDataFlow_fromBin(); //takes the list of data via .dat file
    virtual QList<supAbstractData*> *  getDataFlow(); //pointer/pointer version

    bool getDataFlow(QList <supAbstractData*> & dataFlow, int frameNumber); //takes the list of data via xml file

    virtual bool HasReachedWantedStartTime();
    virtual bool HasReachedWantedStopTime();
	

    bool setFile(const QString &file);
    void setDir(const QString & dir);
    QString getDir();
    QString getFile();

	
	
	int Read_start_year;
	int Read_start_month;
	int Read_start_day;
	int Read_start_hour;
	int Read_start_minute;
	int Read_start_second;
	int Read_start_millisecond;
	
	int Read_stop_year;
	int Read_stop_month;
	int Read_stop_day;
	int Read_stop_hour;
	int Read_stop_minute;
	int Read_stop_second;
	int Read_stop_millisecond;

private:

    DTK_DECLARE_PRIVATE(supAbstractProcessDataFlowReader);
};

#endif

