#ifndef SUPABSTRACTPROCESSEVENTRECOGNITION_H
#define SUPABSTRACTPROCESSEVENTRECOGNITION_H

#include "supCoreExport.h"

#include <supCore/supAbstractProcess.h>

#include "supDataActor.h"
#include "supDataEvent.h"

class supAbstractProcessEventRecognitionPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessEventRecognition interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessEventRecognition : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessEventRecognition(void);
             supAbstractProcessEventRecognition(const supAbstractProcessEventRecognition& other);
    virtual ~supAbstractProcessEventRecognition(void);


public:
   //virtual void setActors( uint64_t timestamp, Actors & actorsList);

    virtual void            setActors(std::list <QSharedPointer <const supDataActor> > l_actorList);

    virtual                 std::list < QSharedPointer<supDataEvent> > getCurrentFrameEvents();

    virtual                 std::list < QSharedPointer<supDataEvent> > getAllFramesEvents();


    virtual bool            performEventRecognition(void) = 0;

    virtual void            setParameterFile( const std::string &fileName);
    virtual bool            getParamSaveXML1File();
    virtual std::string     getParamXML1FileName();

    virtual void    init();

    virtual void            setCommonFilePath(const std::string   &filePath);
    virtual std::string     generateEventListStorageStream();
    virtual std::string     generateEventListStreamToNotify();


private:
    DTK_DECLARE_PRIVATE(supAbstractProcessEventRecognition);
};

#endif

